<?/*
   * This source is made by flupke - flupke@wanadoo.fr
   *
   * This program is modifiable/redistributable under the terms of the GNU
   * General Public License.
   *
   * You should have recieved a copy of the GNU General Public License along
   * with this program; see the file COPYING. If not, write to the Free Software
   * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 0211-1307, USA.
   *
   */?>
<?php

/////////////////////////////////////////////////////////////////////////////
// functions to facilitate rendering of HTML common entities               //
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
function mkSrcName($prefix, $style, $name) {
  return "$prefix/$style/$name";
}

/////////////////////////////////////////////////////////////////////////////
function mkImgName($num, $type, $style, $prefix, $ext) {
  return "$prefix/$style/images/" . $type . "_$num.$ext";
}

/////////////////////////////////////////////////////////////////////////////
// renders a simple nav bar

function renderBar($contents, $bg = "#000000", $border = 1, $glob_width = "no", $prefix = "", $suffix = "", $gen_cols = true, $link_class = "", $content_sep = "", $selected_id = -1) {
  $nbFields = sizeof($contents);  

  if ($gen_cols == false) {
    $rowHeader = "<td bgcolor=\"$bg\" align=\"middle\">";
  }

  if ($link_class != "") {
    $linkOpt = " class=\"$link_class\"";
  }

  // make navbar selected entry bold
  if ($selected_id >= 0) {
    for ($i = 0 ; $i < count($contents) ; $i++) {
      if ($i == $selected_id)
        $contents[$i][0] = "<b>" . $contents[$i][0] . "</b>";    
    }
  }

  if ($glob_width == "no") {
    // determine total width of array
    $width = 0;
    for ($i = 0 ; $i < $nbFields ; $i++) {
      $width += $contents[$i][2];
    }

    echo "<table width=\"$width\" border=\"$border\" cellspacing=\"0\" cellpadding=\"0\">";
    echo $prefix;
    echo "<tr>";

    if ($gen_cols == false) {
      echo $rowHeader;
    }
    
    for ($i = 0 ; $i < $nbFields ; $i++) {
      if ($gen_cols == true) {
        echo "<td align=\"middle\" width=\"" . $contents[$i][2] . "\" bgcolor=\"$bg\"><a $linkOpt href=\"" . $contents[$i][1] . "\">" . $contents[$i][0] . "</a>";
        if ($i != $nbFields - 1) {
          echo $content_sep;
        }
        echo "</td>";
      } else {
        echo "<a $linkOpt href=\"" . $contents[$i][1] . "\">" . $contents[$i][0] . "</a>";
        if ($i != $nbFields - 1) {
          echo $content_sep;
        }
      }
    }
    
    if ($gen_cols == false) {
      echo "</td>";
    }
  } else if ($glob_width == "") {
    echo "<table border=\"$border\" cellspacing=\"0\" cellpadding=\"0\">";
    echo $prefix;
    echo "<tr>";

    if ($gen_cols == false) {
      echo $rowHeader;
    }

    
    for ($i = 0 ; $i < $nbFields ; $i++) {
      if ($gen_cols == true) {
        echo "<td align=\"middle\" bgcolor=\"$bg\"><a $linkOpt href=\"" . $contents[$i][1] . "\">" . $contents[$i][0] . "</a>";
        if ($i != $nbFields - 1) {
          echo $content_sep;
        }
        echo "</td>";
      } else {
        echo "<a $linkOpt href=\"" . $contents[$i][1] . "\">" . $contents[$i][0] . "</a>";
        if ($i != $nbFields - 1) {
          echo $content_sep;
        }
      }
    }
    
    if ($gen_cols == false) {
      echo "</td>";
    }
  } else {
    echo "<table width=\"$glob_width\" border=\"$border\" cellspacing=\"0\">";
    echo $prefix;
    echo "<tr>";

    if ($gen_cols == false) {
      echo $rowHeader;
    }
    
    for ($i = 0 ; $i < $nbFields ; $i++) {
      if ($gen_cols == true) {
        echo "<td align=\"middle\" bgcolor=\"$bg\"><a $linkOpt href=\"" . $contents[$i][1] . "\">" . $contents[$i][0] . "</a>";
        if ($i != $nbFields - 1) {
          echo $content_sep;
        }
        echo "</td>";
      } else {
        echo "<a $linkOpt href=\"" . $contents[$i][1] . "\">" . $contents[$i][0] . "</a>";
        if ($i != $nbFields - 1) {
          echo $content_sep;
        }
      }
    }
    
    if ($gen_cols == false) {
      echo "</td>";
    }
  }
  
  echo "</tr>";
  echo $suffix;
  echo "</table>";

}

/////////////////////////////////////////////////////////////////////////////
// renders a styled nav bar 
// contents is an array containing 10 [text, size] cells parameters

function renderStyledBar($contents, $style, $prefix, $ext, $full_width = false, $bgcolor = "#142749") {
  global $styleBarBGColor;
  $nbFields = sizeof($contents);

  if ($bgcolor == "") {
    $bgcolor = $styleBarBGColor;
  }
  
  if ($full_width == false) {
    // determine total width of array
    $width = 0;
    for ($i = 0 ; $i < $nbFields ; $i++) {
      $width += $contents[$i][2];
    }

    echo "<table width=\"$width\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
  } else {
    echo "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";

    // quick hack : set all widths to '*' string
    $ratio = 100 / $nbFields;
    for ($i = 0 ; $i < $nbFields ; $i++) {
      $contents[$i][2] = "$ratio%";
    }    
  }

  // render top of table
  echo "<tr>";
  echo "<td background=\"" . mkImgName(1, "bar", $style, $prefix, $ext) . "\"><img src=\"" . mkImgName(1, "bar", $style, $prefix, $ext) . "\"></td>";
  echo "<td colspan=" . strval($nbFields + $nbFields - 1) . " background=\"" . mkImgName(2, "bar", $style, $prefix, $ext) . "\"></td>";
  echo "<td background=\"" . mkImgName(3, "bar", $style, $prefix, $ext) . "\"><img src=\"" . mkImgName(3, "bar", $style, $prefix, $ext) . "\"></td>";
  echo "</tr>";

  // render middle part
  echo "<tr>";
  echo "<td rowspan=3  background=\"" . mkImgName(4, "bar", $style, $prefix, $ext) . "\"></td>";
  for ($i = 0 ; $i < $nbFields ; $i++) {
    echo "<td align=\"middle\" width=\"" . $contents[$i][2] . "\" rowspan=3 bgcolor=\"$bgcolor\"><a href=\"" . $contents[$i][1] . "\">" . $contents[$i][0] . "</a></td>";
    if ($i != $nbFields - 1) {
      echo "<td background=\"" . mkImgName(5, "bar", $style, $prefix, $ext) . "\"><img src=\"" . mkImgName(5, "bar", $style, $prefix, $ext) . "\"></td>";
    }
  }  
  echo "<td rowspan=3  background=\"" . mkImgName(8, "bar", $style, $prefix, $ext) . "\"></td>";
  echo "</tr>";

  echo "<tr>";
  for ($i = 0 ; $i < $nbFields - 1 ; $i++) {
    echo "<td height=\"10\" background=\"" . mkImgName(6, "bar", $style, $prefix, $ext) . "\"></td>";
  }
  echo "</tr>";

  echo "<tr>";
  for ($i = 0 ; $i < $nbFields - 1 ; $i++) {
    echo "<td background=\"" . mkImgName(7, "bar", $style, $prefix, $ext) . "\"><img src=\"" . mkImgName(7, "bar", $style, $prefix, $ext) . "\"></td>";
  }
  echo "</tr>";
  
  // render bottom of table
  echo "<tr>";
  echo "<td background=\"" . mkImgName(9, "bar", $style, $prefix, $ext) . "\"><img src=\"" . mkImgName(9, "bar", $style, $prefix, $ext) . "\"></td>";
  echo "<td colspan=" . strval($nbFields + $nbFields - 1) . " background=\"" . mkImgName(10, "bar", $style, $prefix, $ext) . "\"></td>";
  echo "<td background=\"" . mkImgName(11, "bar", $style, $prefix, $ext) . "\"><img src=\"" . mkImgName(11, "bar", $style, $prefix, $ext) . "\"></td>";
  echo "</tr>";

  echo "</table>";
}

/////////////////////////////////////////////////////////////////////////////
// outputs a style-sheet link
function outputStyleSheetLink($style, $prefix) {
  echo "<link rel=\"StyleSheet\" type=\"text/css\" href=\"" . mkSrcName($prefix, $style, "styles.css") . "\">\n";
}

/////////////////////////////////////////////////////////////////////////////
function print_array(&$array) {
  echo "[";
  for ($i = 0  ; $i < sizeof($array) ; $i++) {
    echo $array[$i];
    if ($i != sizeof($array) - 1)
      echo ", ";
  }
  echo "]<br>";
}

/////////////////////////////////////////////////////////////////////////////
function print_2D_array(&$array) {
  echo "[<br>";
  $prefix = "&nbsp;&nbsp;";
  for ($i = 0  ; $i < sizeof($array) ; $i++) {
    echo $prefix;
    print_array($array[$i]);
  }
  echo "]<br>";  
}

?>
